'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = enhanceReduce;

var _initStore = require('./initStore');

var _batchActions = require('./batchActions');

function enhanceReduce(reducer) {
  return function enhancedReducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    var action = arguments[1];

    if (action.type === _initStore.TYPE_TRACKER_INIT) {
      return action.payload;
    }

    if (action.type === _batchActions.TYPE_BATCH_ACTIONS) {
      return action.payload.reduce(enhancedReducer, state);
    }

    return reducer(state, action);
  };
}